/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: pwmtest.c 2416 2012-09-07 08:06:20Z ertl-hiro $
 */

/* 
 *  PWMƥȤ
 *  TIM1-CH1(PA8;D750%),TIM1-CH2(PA9:D8 75%)LED³ƥƥ
 */
# if 0
#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include <target_syssvc.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "device.h"
#endif
#include "pwm.h"
#include "pwmtest.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))

/*
 *  ӥΥ顼Υ
 */
Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))

/* USER CODE BEGIN Private defines */
/* Compute the prescaler value to have TIM1 counter clock equal to 10000 Hz */

#define PRESCALER_VALUE     (uint32_t)(((SystemFrequency) / 10000) - 1)

/* Initialize TIMx peripheral as follows:
   + Prescaler = (SystemCoreClock / 10000) - 1
   + Period = (101 - 1)
   + ClockDivision = 0
   + Counter direction = Up
*/
#define PERIOD_VALUE        (uint32_t)(101 - 1)  /* Period Value  */

static TIM_Handle_t htim1;

/*
 *  SW1
 */
void sw_int(void)
{
	syslog_0(LOG_NOTICE, "## sw_int() ##");
}


/*
 *  ᥤ󥿥
 */
void main_task(intptr_t exinf)
{
	TIM_OC_Init_t sConfigOC = {0};
	ER_UINT	ercd;
	int i, pulse;

	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

	/*
	 *  ꥢݡȤν
	 *
	 *  ƥƱꥢݡȤȤʤɡꥢ
	 *  ݡȤץѤߤξˤϤE_OBJ顼ˤʤ뤬پ
	 *  ʤ
	 */
	ercd = serial_opn_por(TASK_PORTID);
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `serial_opn_por'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(serial_ctl_por(TASK_PORTID,
							(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	htim1.Init.Prescaler = PRESCALER_VALUE;
	htim1.Init.CounterMode = TIM_COUNTERMODE_UP;
	htim1.Init.Period = PERIOD_VALUE;
	htim1.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
	htim1.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
	ercd = pwm_init(TIM1_PORTID, &htim1);
	if(ercd != E_OK){
		syslog_1(LOG_ERROR, "TIM1 init error(%d) !", ercd);
		slp_tsk();
	}
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), RCC_AHB1ENR_GPIOAEN);
	pwm_gpio_channel(&htim1, TIM_CHANNEL1_ID, TADR_GPIOA_BASE, TC1_IN1_PIN);
	pwm_gpio_channel(&htim1, TIM_CHANNEL2_ID, TADR_GPIOA_BASE, TC1_IN2_PIN);

	sConfigOC.OCMode = TIM_OCMODE_PWM1;
	sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
	sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;

	for(i = 0 ; i < 50 ; i++){
		syslog_1(LOG_NOTICE, "LED BLINK TIMES(%d)", i);
		for(pulse = 0 ; pulse <= 100 ; pulse += 2){
			pwm_stop(&htim1, TIM_CHANNEL1_ID);
			sConfigOC.Pulse  = 100 - pulse;
			ercd = pwm_start(&htim1, &sConfigOC, TIM_CHANNEL1_ID);
			if(ercd != E_OK){
				syslog_1(LOG_ERROR, "TIM1 channel1 error(%d) !", ercd);
				slp_tsk();
			}
			pwm_stop(&htim1, TIM_CHANNEL2_ID);
			sConfigOC.Pulse  = pulse;
			ercd = pwm_start(&htim1, &sConfigOC, TIM_CHANNEL2_ID);
			if(ercd != E_OK){
				syslog_1(LOG_ERROR, "TIM1 channel2 error(%d) !", ercd);
				slp_tsk();
			}
			dly_tsk(40);
		}
	}
	pwm_stop(&htim1, TIM_CHANNEL1_ID);
	pwm_stop(&htim1, TIM_CHANNEL2_ID);
	syslog_0(LOG_NOTICE, "STOP");
	slp_tsk();

	syslog(LOG_NOTICE, "Sample program ends.");
//	SVC_PERROR(ext_ker());
}
